import URI from '@wiptheia/core/lib/common/uri';
import { ILogger, Resource, ResourceProvider, MaybePromise } from "@wiptheia/core/lib/common";
import { PreferenceProvider } from '@wiptheia/core/lib/browser/preferences';
export declare abstract class AbstractResourcePreferenceProvider extends PreferenceProvider {
    protected preferences: {
        [key: string]: any;
    };
    protected readonly logger: ILogger;
    protected readonly resourceProvider: ResourceProvider;
    protected resource: Promise<Resource>;
    protected init(): Promise<void>;
    abstract getUri(): MaybePromise<URI | undefined>;
    getPreferences(): {
        [key: string]: any;
    };
    setPreference(key: string, value: any): Promise<void>;
    protected readPreferences(): Promise<void>;
    protected readContents(): Promise<string>;
}
