import { CommandContribution, MenuContribution, Command, MenuModelRegistry, CommandRegistry } from "@wiptheia/core";
import { UserPreferenceProvider } from "./user-preference-provider";
import { OpenerService } from "@wiptheia/core/lib/browser";
import { WorkspacePreferenceProvider } from './workspace-preference-provider';
import { FileSystem } from "@wiptheia/filesystem/lib/common";
import { UserStorageService } from "@wiptheia/userstorage/lib/browser";
export declare namespace PreferenceCommands {
    const OPEN_USER_PREFERENCES: Command;
    const OPEN_WORKSPACE_PREFERENCES: Command;
}
export declare class PreferenceFrontendContribution implements CommandContribution, MenuContribution {
    protected readonly userStorageService: UserStorageService;
    protected readonly userPreferenceProvider: UserPreferenceProvider;
    protected readonly workspacePreferenceProvider: WorkspacePreferenceProvider;
    protected readonly openerService: OpenerService;
    protected readonly filesystem: FileSystem;
    registerCommands(commands: CommandRegistry): void;
    registerMenus(menus: MenuModelRegistry): void;
    protected openUserPreferences(): Promise<void>;
    protected openWorkspacePreferences(): Promise<void>;
    private getPreferenceTemplateForScope(scope);
}
