"use strict";
/*
 * Copyright (C) 2018 Ericsson and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 */
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var user_preference_provider_1 = require("./user-preference-provider");
var browser_1 = require("@wiptheia/core/lib/browser");
var workspace_preference_provider_1 = require("./workspace-preference-provider");
var common_1 = require("@wiptheia/filesystem/lib/common");
var browser_2 = require("@wiptheia/userstorage/lib/browser");
var PreferenceCommands;
(function (PreferenceCommands) {
    PreferenceCommands.OPEN_USER_PREFERENCES = {
        id: 'preferences:open_user',
        label: 'Open User Preferences'
    };
    PreferenceCommands.OPEN_WORKSPACE_PREFERENCES = {
        id: 'preferences:open_workspace',
        label: 'Open Workspace Preferences'
    };
})(PreferenceCommands = exports.PreferenceCommands || (exports.PreferenceCommands = {}));
var PreferenceFrontendContribution = /** @class */ (function () {
    function PreferenceFrontendContribution() {
    }
    PreferenceFrontendContribution.prototype.registerCommands = function (commands) {
        var _this = this;
        commands.registerCommand(PreferenceCommands.OPEN_USER_PREFERENCES, {
            isEnabled: function () { return true; },
            execute: function () { return _this.openUserPreferences(); }
        });
        commands.registerCommand(PreferenceCommands.OPEN_WORKSPACE_PREFERENCES, {
            isEnabled: function () { return true; },
            execute: function () { return _this.openWorkspacePreferences(); }
        });
    };
    PreferenceFrontendContribution.prototype.registerMenus = function (menus) {
        menus.registerMenuAction(browser_1.CommonMenus.FILE_OPEN, {
            commandId: PreferenceCommands.OPEN_USER_PREFERENCES.id
        });
        menus.registerMenuAction(browser_1.CommonMenus.FILE_OPEN, {
            commandId: PreferenceCommands.OPEN_WORKSPACE_PREFERENCES.id
        });
    };
    PreferenceFrontendContribution.prototype.openUserPreferences = function () {
        return __awaiter(this, void 0, void 0, function () {
            var userUri, content;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        userUri = this.userPreferenceProvider.getUri();
                        return [4 /*yield*/, this.userStorageService.readContents(userUri)];
                    case 1:
                        content = _a.sent();
                        if (!(content === "")) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.userStorageService.saveContents(userUri, this.getPreferenceTemplateForScope('user'))];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        browser_1.open(this.openerService, userUri);
                        return [2 /*return*/];
                }
            });
        });
    };
    PreferenceFrontendContribution.prototype.openWorkspacePreferences = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wsUri;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.workspacePreferenceProvider.getUri()];
                    case 1:
                        wsUri = _a.sent();
                        if (!wsUri) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.filesystem.exists(wsUri.toString())];
                    case 2:
                        if (!!(_a.sent())) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.filesystem.createFile(wsUri.toString(), { content: this.getPreferenceTemplateForScope('workspace') })];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        browser_1.open(this.openerService, wsUri);
                        return [2 /*return*/];
                }
            });
        });
    };
    PreferenceFrontendContribution.prototype.getPreferenceTemplateForScope = function (scope) {
        return "/*\nPreference file for " + scope + " scope\n\nPlease refer to the documentation online (https://github.com/theia-ide/theia/blob/master/packages/preferences/README.md) to learn how preferences work in Theia\n*/";
    };
    __decorate([
        inversify_1.inject(browser_2.UserStorageService),
        __metadata("design:type", Object)
    ], PreferenceFrontendContribution.prototype, "userStorageService", void 0);
    __decorate([
        inversify_1.inject(browser_1.PreferenceProvider), inversify_1.named(browser_1.PreferenceScope.User),
        __metadata("design:type", user_preference_provider_1.UserPreferenceProvider)
    ], PreferenceFrontendContribution.prototype, "userPreferenceProvider", void 0);
    __decorate([
        inversify_1.inject(browser_1.PreferenceProvider), inversify_1.named(browser_1.PreferenceScope.Workspace),
        __metadata("design:type", workspace_preference_provider_1.WorkspacePreferenceProvider)
    ], PreferenceFrontendContribution.prototype, "workspacePreferenceProvider", void 0);
    __decorate([
        inversify_1.inject(browser_1.OpenerService),
        __metadata("design:type", Object)
    ], PreferenceFrontendContribution.prototype, "openerService", void 0);
    __decorate([
        inversify_1.inject(common_1.FileSystem),
        __metadata("design:type", Object)
    ], PreferenceFrontendContribution.prototype, "filesystem", void 0);
    PreferenceFrontendContribution = __decorate([
        inversify_1.injectable()
    ], PreferenceFrontendContribution);
    return PreferenceFrontendContribution;
}());
exports.PreferenceFrontendContribution = PreferenceFrontendContribution;
//# sourceMappingURL=preference-frontend-contribution.js.map