"use strict";
/*
 * Copyright (C) 2018 Ericsson and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 */
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var preferences_1 = require("@wiptheia/core/lib/browser/preferences");
var user_preference_provider_1 = require("./user-preference-provider");
var workspace_preference_provider_1 = require("./workspace-preference-provider");
var preference_frontend_contribution_1 = require("./preference-frontend-contribution");
var common_1 = require("@wiptheia/core/lib/common");
function bindPreferences(bind, unbind) {
    unbind(preferences_1.PreferenceProvider);
    bind(preferences_1.PreferenceProvider).to(user_preference_provider_1.UserPreferenceProvider).inSingletonScope().whenTargetNamed(preferences_1.PreferenceScope.User);
    bind(preferences_1.PreferenceProvider).to(workspace_preference_provider_1.WorkspacePreferenceProvider).inSingletonScope().whenTargetNamed(preferences_1.PreferenceScope.Workspace);
    bind(preference_frontend_contribution_1.PreferenceFrontendContribution).toSelf().inSingletonScope();
    bind(common_1.CommandContribution).toService(preference_frontend_contribution_1.PreferenceFrontendContribution);
    bind(common_1.MenuContribution).toService(preference_frontend_contribution_1.PreferenceFrontendContribution);
}
exports.bindPreferences = bindPreferences;
exports.default = new inversify_1.ContainerModule(function (bind, unbind, isBound, rebind) {
    bindPreferences(bind, unbind);
});
//# sourceMappingURL=preference-frontend-module.js.map